import { ActiveRecord, ActiveRecords, DeleteActiveRecordsByEntityPredict, RuntimeM2MField, RuntimeO2MField, SubmitCacheManager } from '@oinone/kunlun-engine';
import { ViewType } from '@oinone/kunlun-meta';
import { Condition } from '@oinone/kunlun-request';
import { ReturnPromise } from '@oinone/kunlun-shared';
import { ComputeTrigger, WidgetTrigger } from '@oinone/kunlun-vue-ui-common';
import { IFormSubviewListFieldWidget, RefreshProcessFunction } from '../../../types';
import { FormComplexFieldProps } from '../FormComplexFieldWidget';
import { FormSubviewFieldWidget } from './FormSubviewFieldWidget';
export declare class FormSubviewListFieldWidget<Field extends RuntimeO2MField | RuntimeM2MField = RuntimeO2MField | RuntimeM2MField, Props extends FormComplexFieldProps<Field> = FormComplexFieldProps<Field>> extends FormSubviewFieldWidget<ActiveRecord[], Field, Props> implements IFormSubviewListFieldWidget<Field> {
    protected defaultSubviewType: ViewType;
    protected subviewSubmitCache: SubmitCacheManager | undefined;
    initialize(props: any): this;
    protected initSubviewAfterProperties(props: Props): void;
    protected parentRefreshProcess: RefreshProcessFunction | undefined;
    protected refreshProcess(condition?: Condition): Promise<void>;
    get dataSource(): ActiveRecord[] | undefined;
    set dataSource(dataSource: ActiveRecord[] | undefined);
    reloadDataSource(records: ActiveRecords | undefined): void;
    get activeRecords(): ActiveRecord[] | undefined;
    set activeRecords(activeRecords: ActiveRecord[] | undefined);
    reloadActiveRecords(records: ActiveRecords | undefined): void;
    deleteDataSource(recordIndexes: number[]): void;
    deleteDataSourceByEntity(records: ActiveRecords, predict?: DeleteActiveRecordsByEntityPredict): void;
    afterTriggerExecute(trigger: WidgetTrigger): Promise<void>;
    flushDataSource(reloadDataSource?: boolean): void;
    protected repairTablePagination(): void;
    protected defaultComputeTrigger: ComputeTrigger[];
    protected defaultConstructDataTrigger(): WidgetTrigger[];
    protected defaultClearFieldsTrigger(): WidgetTrigger[];
    protected mountedProcess(): Promise<void>;
    protected refreshParentProcess(): Promise<void>;
    protected refreshValueProcess(): Promise<void>;
    protected initSubviewData(): ReturnPromise<void>;
}
